// aboutdlg.h : interface of the CAboutDlg class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_ABOUTDLG_H__5FF6DF87_D992_4D6C_B87F_733856B87CE0__INCLUDED_)
#define AFX_ABOUTDLG_H__5FF6DF87_D992_4D6C_B87F_733856B87CE0__INCLUDED_

      // Cool blend-in animation effect (Win2K only)
#ifndef AW_BLEND
#define AW_HIDE                     0x00010000
#define AW_ACTIVATE                 0x00020000
#define AW_BLEND                    0x00080000
#endif
typedef VOID (CALLBACK* LPFNANIMATEWINDOW)(HWND,DWORD,DWORD);

class CAboutDlg : public CDialogImpl<CAboutDlg>
{
public:
   enum { IDD = IDD_ABOUTBOX };

   CHyperLink m_ctlMail;
   CHyperLink m_ctlWeb;

   BEGIN_MSG_MAP(CAboutDlg)
      MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
      COMMAND_ID_HANDLER(IDOK, OnCloseCmd)
      COMMAND_ID_HANDLER(IDCANCEL, OnCloseCmd)
   END_MSG_MAP()

   LRESULT OnInitDialog(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
   {
      m_ctlMail.SubclassWindow(GetDlgItem(IDC_EMAIL));
      m_ctlMail.SetLabel(_T("Bjarke Viksoe"));
      m_ctlMail.SetHyperLink(_T("mailto:bjarke@viksoe.dk"));
      m_ctlWeb.SubclassWindow(GetDlgItem(IDC_WEB));
      m_ctlWeb.SetLabel(_T("www.viksoe.dk/code"));
      m_ctlWeb.SetHyperLink(_T("http://www.viksoe.dk/code"));
      
      CenterWindow(GetParent());

      // Add cool fade effect
      if( !AtlIsOldWindows() ) {
         LPFNANIMATEWINDOW lpfnAnimateWindow = (LPFNANIMATEWINDOW)
            ::GetProcAddress(::GetModuleHandle(_T("user32.dll")), _T("AnimateWindow"));
         if( lpfnAnimateWindow!=NULL )
            lpfnAnimateWindow( m_hWnd, 200, AW_BLEND | AW_ACTIVATE );
      }

      return TRUE;
   }

   LRESULT OnCloseCmd(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
   {
      // Add cool fade effect
      if( !AtlIsOldWindows() ) {
         LPFNANIMATEWINDOW lpfnAnimateWindow = (LPFNANIMATEWINDOW)
            ::GetProcAddress(::GetModuleHandle(_T("user32.dll")), _T("AnimateWindow"));
         if( lpfnAnimateWindow!=NULL )
            lpfnAnimateWindow( m_hWnd, 200, AW_BLEND | AW_HIDE );
      }

      EndDialog(wID);
      return 0;
   }
};

#endif // !defined(AFX_ABOUTDLG_H__5FF6DF87_D992_4D6C_B87F_733856B87CE0__INCLUDED_)
