// FileMess.cpp : main source file for FileMess.exe
//

#include "stdafx.h"


#include "resource.h"

#include "FileMessView.h"
#include "aboutdlg.h"
#include "macrosdlg.h"
#include "optionsdlg.h"
#include "entrydlg.h"
#include "MainFrm.h"

CAppModule _Module;


DWORD dwID = 0;

DWORD GetNewID()
{
   return ++dwID;
};

int Run(LPTSTR /*lpstrCmdLine*/ = NULL, int nCmdShow = SW_SHOWDEFAULT)
{
   CMessageLoop theLoop;
   _Module.AddMessageLoop(&theLoop);

   CMainFrame wndMain;

   if(wndMain.CreateEx() == NULL)
   {
      ATLTRACE(_T("Main window creation failed!\n"));
      return 0;
   }

   wndMain.ShowWindow(nCmdShow);

   int nRet = theLoop.Run();

   _Module.RemoveMessageLoop();
   return nRet;
}

int WINAPI _tWinMain(HINSTANCE hInstance, HINSTANCE /*hPrevInstance*/, LPTSTR lpstrCmdLine, int nCmdShow)
{
   // Fake a COM server registration
   CString sCmdLine(lpstrCmdLine);
   sCmdLine.MakeUpper();
   if( sCmdLine.Find(_T("/REGSERVER")) >=0 ) return 0;
   if( sCmdLine.Find(_T("/UNREGSERVER")) >=0 ) return 0;

   HRESULT hRes = ::CoInitialize(NULL);
   ATLASSERT(SUCCEEDED(hRes));

   INITCOMMONCONTROLSEX iccx;
   iccx.dwSize = sizeof(iccx);
   iccx.dwICC = ICC_COOL_CLASSES | ICC_BAR_CLASSES | ICC_DATE_CLASSES;
   BOOL bRet = ::InitCommonControlsEx(&iccx);
   ATLASSERT(bRet);

   hRes = _Module.Init(NULL, hInstance);
   ATLASSERT(SUCCEEDED(hRes));

   int nRet = Run(lpstrCmdLine, nCmdShow);

   _Module.Term();
   ::CoUninitialize();

   return nRet;
}
