// FileMessView.h : interface of the CFileMessView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_FILEMESSVIEW_H__0A6AC87E_14A5_47B6_9270_23BA3DD0C369__INCLUDED_)
#define AFX_FILEMESSVIEW_H__0A6AC87E_14A5_47B6_9270_23BA3DD0C369__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

int CALLBACK ListViewCompareProc(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort);


class CFileMessView : public CWindowImpl<CFileMessView, CListViewCtrl>
{
public:
   DECLARE_WND_SUPERCLASS(NULL, CListViewCtrl::GetWndClassName())

   BOOL PreTranslateMessage(MSG* pMsg)
   {
      pMsg;
      return FALSE;
   }

   BEGIN_MSG_MAP(CFileMessView)
      MESSAGE_HANDLER(WM_CREATE, OnCreate)
      ALT_MSG_MAP(1)
   END_MSG_MAP()

   CFileMessView()
   {
   };

   LRESULT OnCreate(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
   {
      LRESULT lRet = DefWindowProc(uMsg, wParam, lParam);

      // Add the headers for the ListView control
      CString strHeader;
      strHeader.LoadString(IDS_COL_TITLE);
      InsertColumn(0, strHeader, LVCFMT_LEFT, 200, 1);
      strHeader.LoadString(IDS_COL_PATTERN);
      InsertColumn(1, strHeader, LVCFMT_LEFT, 100, 1);
      strHeader.LoadString(IDS_COL_FILES);
      InsertColumn(2, strHeader, LVCFMT_CENTER, 80, 1);
      strHeader.LoadString(IDS_COL_NEWFILES);
      InsertColumn(3, strHeader, LVCFMT_CENTER, 80, 1);
      
      SetExtendedListViewStyle(LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES);

      bHandled = FALSE;
      return lRet;
   }

};


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_FILEMESSVIEW_H__0A6AC87E_14A5_47B6_9270_23BA3DD0C369__INCLUDED_)
